/*!\file KML_Style.cpp
 * \brief: implementation of the kml_style object
 */

/*Headers:*/
/*{{{1*/
#ifdef HAVE_CONFIG_H
	#include "config.h"
#else
#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
#endif

#include "stdio.h"
#include <string.h>
#include "../objects.h"
#include "../../shared/shared.h"
#include "../../Container/Container.h"
#include "../../include/include.h"
/*}}}*/

/*Constructors/destructor/copy*/
/*FUNCTION KML_Style::KML_Style(){{{1*/
KML_Style::KML_Style(){

	icon      =NULL;
	label     =NULL;
	line      =NULL;
	poly      =NULL;
	balloon   =NULL;
	list      =NULL;

}
/*}}}*/
/*FUNCTION KML_Style::~KML_Style(){{{1*/
KML_Style::~KML_Style(){

	if (list) {
//		delete list;
		if (list      ) xfree((void**)&list);
		list      =NULL;
	}
	if (balloon) {
//		delete balloon;
		if (balloon   ) xfree((void**)&balloon);
		balloon   =NULL;
	}
	if (poly) {
		delete poly;
		poly      =NULL;
	}
	if (line) {
		delete line;
		line      =NULL;
	}
	if (label) {
//		delete label;
		if (label     ) xfree((void**)&label);
		label     =NULL;
	}
	if (icon) {
//		delete icon;
		if (icon      ) xfree((void**)&icon);
		icon      =NULL;
	}

}
/*}}}*/

/*Other*/
/*FUNCTION KML_Style::Echo {{{1*/
void  KML_Style::Echo(){

	bool  flag=true;

	_printf_(flag,"KML_Style:\n");
	KML_StyleSelector::Echo();

	_printf_(flag,"          icon: %p\n"          ,icon);
	_printf_(flag,"         label: %p\n"          ,label);
	_printf_(flag,"          line: %p\n"          ,line);
	_printf_(flag,"          poly: %p\n"          ,poly);
	_printf_(flag,"       balloon: %p\n"          ,balloon);
	_printf_(flag,"          list: %p\n"          ,list);

	return;
}
/*}}}*/

/*FUNCTION KML_Style::DeepEcho {{{1*/
void  KML_Style::DeepEcho(){

	char  indent[81]="";

	KML_Style::DeepEcho(indent);

	return;
}
/*}}}*/

/*FUNCTION KML_Style::DeepEcho {{{1*/
void  KML_Style::DeepEcho(char* indent){

	int   i;
	char  indent2[81];
	bool  flag=true;

	_printf_(flag,"%sKML_Style:\n",indent);
	KML_StyleSelector::DeepEcho(indent);

	strcpy(indent2,indent);
	strcat(indent2,"  ");

//	if (icon)
//		icon->DeepEcho(indent2);
//	else
		_printf_(flag,"%s          icon: %p\n"          ,indent,icon);
//	if (label)
//		label->DeepEcho(indent2);
//	else
		_printf_(flag,"%s         label: %p\n"          ,indent,label);
	if (line)
		line->DeepEcho(indent2);
	else
		_printf_(flag,"%s          line: %p\n"          ,indent,line);
	if (poly)
		poly->DeepEcho(indent2);
	else
		_printf_(flag,"%s          poly: %p\n"          ,indent,poly);
//	if (balloon)
//		balloon->DeepEcho(indent2);
//	else
		_printf_(flag,"%s       balloon: %p\n"          ,indent,balloon);
//	if (list)
//		list->DeepEcho(indent2);
//	else
		_printf_(flag,"%s          list: %p\n"          ,indent,list);

	return;
}
/*}}}*/

/*FUNCTION KML_Style::Write {{{1*/
void  KML_Style::Write(FILE* filout,char* indent){

	int   i;
	char  indent2[81];

	if (this->id && strlen(this->id))
		fprintf(filout,"%s<Style id=\"%s\">\n",indent,this->id);
	else
		fprintf(filout,"%s<Style>\n",indent);

	KML_StyleSelector::Write(filout,indent);

	strcpy(indent2,indent);
	strcat(indent2,"  ");

//	if (icon)
//		icon->Write(filout,indent2);
//	if (label)
//		label->Write(filout,indent2);
	if (line)
		line->Write(filout,indent2);
	if (poly)
		poly->Write(filout,indent2);
//	if (balloon)
//		balloon->Write(filout,indent2);
//	if (list)
//		list->Write(filout,indent2);

	fprintf(filout,"%s</Style>\n",indent);

	return;
}
/*}}}*/

/*FUNCTION KML_Style::Id {{{1*/
int   KML_Style::Id(){
}
/*}}}*/

/*FUNCTION KML_Style::MyRank {{{1*/
int   KML_Style::MyRank(){
}
/*}}}*/

/*FUNCTION KML_Style::Marshall {{{1*/
void  KML_Style::Marshall(char** pmarshalled_dataset){
}
/*}}}*/

/*FUNCTION KML_Style::MarshallSize {{{1*/
int   KML_Style::MarshallSize(){
}
/*}}}*/

/*FUNCTION KML_Style::Demarshall {{{1*/
void  KML_Style::Demarshall(char** pmarshalled_dataset){
}
/*}}}*/

/*FUNCTION KML_Style::Enum {{{1*/
int   KML_Style::Enum(){
}
/*}}}*/

/*FUNCTION KML_Style::copy {{{1*/
Object* KML_Style::copy(){
}
/*}}}*/

